------------------------------------------------------------------------------
--                                                                          --
--                          ADABROKER COMPONENTS                            --
--                                                                          --
--                B R O C A . T A S K _ A T T R I B U T E S                 --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--          Copyright (C) 1999-2000 ENST Paris University, France.          --
--                                                                          --
-- AdaBroker is free software; you  can  redistribute  it and/or modify it  --
-- under terms of the  GNU General Public License as published by the  Free --
-- Software Foundation;  either version 2,  or (at your option)  any  later --
-- version. AdaBroker  is distributed  in the hope that it will be  useful, --
-- but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License distributed with AdaBroker; see file COPYING. If  --
-- not, write to the Free Software Foundation, 59 Temple Place - Suite 330, --
-- Boston, MA 02111-1307, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
--             AdaBroker is maintained by ENST Paris University.            --
--                     (email: broker@inf.enst.fr)                          --
--                                                                          --
------------------------------------------------------------------------------

with PortableServer;

pragma Elaborate (PortableServer);

package Broca.Task_Attributes is

   function Has_Context return Boolean;
   pragma Inline (Has_Context);

   function Current_Object return PortableServer.ObjectId;
   pragma Inline (Current_Object);

   function Current_POA return PortableServer.POA_Forward.Ref;
   pragma Inline (Current_POA);

   procedure Set_Current_Object (Val : PortableServer.ObjectId);
   pragma Inline (Set_Current_Object);

   procedure Set_Current_POA (Val : PortableServer.POA_Forward.Ref);
   pragma Inline (Set_Current_POA);

   procedure Set_Has_Context (Context : in Boolean := True);
   pragma Inline (Set_Has_Context);

   procedure Set_Has_No_Context (Context : in Boolean := False)
     renames Set_Has_Context;

end Broca.Task_Attributes;
